#NoAutoIt3Execute
#include "_HotKey.au3"
#include "_ArraySearchAnyDim.au3"
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <ListViewConstants.au3>
#include <WindowsConstants.au3>
#include <Misc.au3>
Opt("TrayMenuMode", 3)
Opt("TrayOnEventMode", 1)
Const $ConstVer = "0.7.1B"
#EndRegion

#Region::: Ensure only one copy of schemeHK is running
If _Singleton("SchemeHK-AFE93AF4A6F096F719759E4BE877702C", 1) = 0 Then
	MsgBox(0, "Error", "SchemeHK is already running.")
	Exit
EndIf
#EndRegion


#Region::: Set up tray menu
TraySetClick(9)
TrayCreateItem("Settings...")
TrayItemSetOnEvent(-1, "TraySettings")
TrayCreateItem("Exit")
TrayItemSetOnEvent(-1, "TrayExit")
#EndRegion

#Region::: Read hotkeys from ini and enable them
ReadHotKeys()
SetHotKeys()
#EndRegion

#Region::: Function to read hotkeys from ini
Func ReadHotKeys()
	Global $HotKeys = IniReadSection(".\SchemeHK.ini", "HotKeys")
EndFunc   ;==>ReadHotKeys
#EndRegion

#Region::: Function to enable or disable hotkeys
Func SetHotKeys($Disabled = 0)
	If Not IsArray($HotKeys) Then Return
	For $X = 1 To $HotKeys[0][0]
		Select
			Case $Disabled = 1
				HotKeySet($HotKeys[$X][1]) ; Disable hotkey
			Case Else
				If $HotKeys[$X][1]<>"Disabled" then HotKeySet($HotKeys[$X][1], "OnHK") ;Enable hotkey
		EndSelect
	Next
EndFunc   ;==>SetHotKeys
#EndRegion
#Region::: do nothing loop so script can grab hotkeys
While 1
	Sleep(1000)
	$Active = _PowerScheme_GetActive()
	If IsArray($Active) Then TraySetToolTip("SchemeHK:" & $Active[1])
WEnd
#EndRegion

#Region::: Tray functions
Func TraySettings()
	SetHotKeys(1);Disable hotkeys while form is open

	$Form = GUICreate("SchemeHK V" & $ConstVer, 425, 195)
	$ListView = GUICtrlCreateListView("Name|HotKey", 8, 8, 410, 150)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 200)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 205)
	$ButtonOK = GUICtrlCreateButton("OK", 264, 160, 75, 25, $WS_GROUP)
	$ButtonCancel = GUICtrlCreateButton("Cancel", 344, 160, 75, 25, $WS_GROUP)


	$Schemes = _PowerScheme_List() ; List power schemes that are on the system
	Dim $LVItems[$Schemes[0][0] + 1]
	$LVItems[0] = $Schemes[0][0] ; Create an array to hold the listview items
	For $X = 1 To $Schemes[0][0]
		$LVItems[$X] = GUICtrlCreateListViewItem($Schemes[$X][1] & "|" & _HotKeyToString(IniRead(".\SchemeHK.ini", "HotKeys", $Schemes[$X][0], "Disabled")), $ListView)
	Next

	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $ButtonCancel
				SetHotKeys()
				GUIDelete()
				Return
			Case $ButtonOK
				For $X = 1 To $LVItems[0]
					$Split = StringSplit(GUICtrlRead($LVItems[$X]), "|")
					IniWrite(".\SchemeHK.ini", "HotKeys", $Schemes[$X][0], _StringToHotKey($Split[2]))
				Next
				GUIDelete()
				ReadHotKeys()
				SetHotKeys()
				Return
		EndSwitch
		For $X = 1 To $LVItems[0] ;Handle clicking of listview items
			If $nMsg = $LVItems[$X] Then
				$Choice = _ChooseHotKey(_StringToHotKey(__ReturnHK($LVItems[$X])), 0, 'Choose HotKey', Default, Default, Default, Default, $Form)
				If Not @error Then GUICtrlSetData($LVItems[$X], "|" & _HotKeyToString($Choice))
			EndIf
		Next
	WEnd

EndFunc   ;==>TraySettings

Func TrayExit()
	Exit
EndFunc   ;==>TrayExit
#EndRegion

#Region::: Function to handle hotkeys
Func OnHK()
	$Search = _ArraySearchAnyDim($HotKeys, @HotKeyPressed, 0, 0, 0, "[x][1]") ;Find corresponding GUID for hotkey
	_PowerScheme_SetActive($HotKeys[$Search][0]) ; Change powerplan to found GUID
	$Active = _PowerScheme_GetActive()
	If IsArray($Active) Then TrayTip("SchemeHK", $Active[1] & " is now the active power scheme.", 3) ;Display Tooltip with powerplan
EndFunc   ;==>OnHK
#EndRegion

#Region::: Function for getting the hotkey from a listview
Func __ReturnHK($Item)
	$Split = StringSplit(GUICtrlRead($Item), "|")
	Return $Split[2]
EndFunc   ;==>__ReturnHK
#EndRegion
